Subject: Re: [PATCH 1/2] net: phylib: add adjust_state callback to phy device

From: Daniel Mack <[email-masked]>
Date: Fri, 15 Nov 2013 08:35:00 +0100

On 11/14/2013 10:32 PM, David Miller wrote:
> From: Daniel Mack <[email-masked]>
> Date: Wed, 13 Nov 2013 22:07:49 +0100
> 
>> Allow phy drivers to take action when the core does its link adjustment.
>> No change for drivers that do not implement this callback.
>>
>> Signed-off-by: Daniel Mack <[email-masked]>
> 
> So you're using this to reset the entire PHY via the reset bit in the
> BMCR register when the link goes down.
> 
> But this is going to break things.
> 
> If the phy library previously programmed a non-autonegotiated static
> link configuration into the BMCR register, your reset is going to
> undo that.
> 
> Now the configuration phylib thinks the chip has and the one it
> acutally does is out of sync.

You're right, thanks for the review. Let me just state that I'm really
unhappy about that approach as well.

However, I currently see no better way than resetting the PHY every time
the link goes down, as we have no way of telling whether the chip has
entered its locked-up state which it seemingly does arbitrarily when the
link changes. This is really not nice, but the only thing that avoided
the effect in our tests.

That means that we either have to tell the PHY core about what we did,
or manually preserve the registers contents across the reset. I'll have
another look next week. Any pointers appreciated :)

Daniel